Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15189)
@@ -0,0 +1,110 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Individual {
+  using System;
+  using Configuration;
+  using Core;
+  using Data.Pool;
+  using Encodings.IntegerVectorEncoding;
+  using Expressions;
+  using Extensions;
+  using Generators.CodeGenerator;
+
+  public class ListCheck {
+    public PooledList<Expression> List { get; set; }
+    public IManagedPool<PooledList<Expression>> Pool { get; set; }
+    public IndividualMapper Mapper { get; set; }
+  }
+
+  public class IndividualMapper : IDisposable {
+    private static readonly ObjectPool<IndividualMapper> MapperPool = new ObjectPool<IndividualMapper>(() => new IndividualMapper());
+    private static readonly ManagedPoolProvider<PushProgram> PushProgramPoolProvider = new ManagedPoolProvider<PushProgram>(1000, () => new PushProgram());
+    private static readonly ManagedPoolProvider<PooledList<Expression>> ExpressionListPoolProvider = new ManagedPoolProvider<PooledList<Expression>>(1000, () => new PooledList<Expression>());
+
+    private readonly IManagedPool<PushProgram> pushProgramPool = PushProgramPoolProvider.CreatePool();
+    private readonly IManagedPool<PooledList<Expression>> expressionListPool = ExpressionListPoolProvider.CreatePool();
+
+    private IndividualMapper() { }
+
+    public PushProgram FromPlush(
+      IntegerVector vector,
+      ref int currentIndex,
+      ref int close,
+      int depth,
+      IReadOnlyPushConfiguration config,
+      IRandom random) {
+
+      if (currentIndex >= vector.Length)
+        return PushProgram.Empty;
+
+      var expressions = expressionListPool.Get();
+
+      for (; currentIndex < vector.Length; currentIndex++) {
+        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
+          vector[currentIndex] % config.EnabledExpressions.Count,
+          random,
+          config.EnabledExpressions,
+          config.ErcOptions);
+
+        var expressionType = expression.GetType();
+
+        if (config.ParenthesesCloseBiasLevel > 0) {
+          close += random.NextBiased(0, config.MaxParenthesesClose, config.ParenthesesCloseBiasLevel);
+
+          // check if expression requires additional blocks
+          if (ExpressionTable.TypeToAttributeTable.ContainsKey(expressionType)) {
+            var attr = ExpressionTable.TypeToAttributeTable[expressionType];
+
+            for (var blockIdx = 0u; blockIdx < attr.ExecIn && currentIndex < vector.Length; blockIdx++) {
+              if (close != 0) {
+                close--;
+                expressions.Add(PushProgram.Empty);
+              } else {
+                currentIndex++;
+                var subProgram = FromPlush(vector, ref currentIndex, ref close, depth + 1, config, random);
+                var subExpression = subProgram.Count == 1 ? subProgram.Expressions[0] : subProgram;
+
+                expressions.Add(subExpression);
+              }
+            }
+          }
+        }
+
+        expressions.Add(expression);
+
+        if (close > 0 && depth > 0) {
+          close--;
+          break;
+        }
+
+        if (depth == 0) {
+          close = 0;
+        }
+      }
+
+      return PushProgram.Create(pushProgramPool, expressions);
+    }
+
+    public static IndividualMapper Create() {
+      return MapperPool.Allocate();
+    }
+
+    public static void Reset() {
+      foreach (var mapper in MapperPool.Items) {
+        mapper.expressionListPool.Release();
+        mapper.pushProgramPool.Release();
+      }
+    }
+
+    public static void Clear() {
+      Reset();
+
+      PushProgramPoolProvider.Clear();
+      ExpressionListPoolProvider.Clear();
+
+      MapperPool.Clear();
+    }
+
+    public void Dispose() {
+      MapperPool.Free(this);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15189)
@@ -25,21 +25,29 @@
 
     public static Type GetStackEntryType(this StackTypes stackType) {
+      if (StackProperties.ContainsKey(stackType) &&
+          StackProperties[stackType].PropertyType.IsGenericType) {
+        var genericTypeDef = StackProperties[stackType].PropertyType.GetGenericTypeDefinition();
+        if (genericTypeDef == typeof(IPushStack<>))
+          return genericTypeDef.GetGenericArguments()[0];
+      }
+
       return StackProperties.ContainsKey(stackType)
-        ? StackProperties[stackType].PropertyType.GetGenericArguments().Single()
+        ? StackProperties[stackType]
+            .PropertyType
+            .GetInterfaces()
+            .First(i => i.IsGenericType && i.GetGenericTypeDefinition() == typeof(IPushStack<>))
+            .GetGenericArguments()
+            .First()
         : null;
     }
 
     public static void PrintStacks(this IPushInterpreter interpreter) {
-      var stackTypesType = typeof(StackTypes);
-
-      foreach (StackTypes type in Enum.GetValues(stackTypesType)) {
-        if (!interpreter.Stacks.ContainsKey(type)) continue;
-
-        var stackName = Enum.GetName(stackTypesType, type);
-        var stack = interpreter.Stacks[type];
+      foreach (var pair in interpreter.Stacks) {
+        var stackName = pair.Key.ToString();
+        var stack = interpreter.Stacks[pair.Key];
 
         if (stack.IsEmpty || !stack.IsEnabled) continue;
 
-        var stackString = string.Join(" ", interpreter.StringifyStack(type).Reverse());
+        var stackString = string.Join(" ", interpreter.StringifyStack(pair.Key).Reverse());
         Console.WriteLine("--------- {0} ---------\n{1}\n", stackName, stackString);
       }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IInternalPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IInternalPushInterpreter.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IInternalPushInterpreter.cs	(revision 15189)
@@ -1,6 +1,11 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
+  using System.Collections.Generic;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
   public interface IInternalPushInterpreter : IPushInterpreter {
     InterpreterPoolContainer PoolContainer { get; }
     bool IsNameQuoteFlagSet { get; set; }
+    IReadOnlyList<Expression> InputExpressions { get; }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15189)
@@ -24,5 +24,5 @@
     IPushStack<IReadOnlyList<bool>> BooleanVectorStack { get; }
     IPushStack<IReadOnlyList<string>> StringVectorStack { get; }
-    IPushStack<string> PrintStack { get; }
+    IPrintStack PrintStack { get; }
     IDictionary<string, Expression> CustomExpressions { get; }
     IReadOnlyDictionary<StackTypes, IPushStack> Stacks { get; }
@@ -30,4 +30,14 @@
     void Clear();
     void Reset();
+
+    void SetInput(
+      IReadOnlyList<long> integers = null,
+      IReadOnlyList<double> floats = null,
+      IReadOnlyList<bool> booleans = null,
+      IReadOnlyList<char> chars = null,
+      IReadOnlyList<string> strings = null,
+      IReadOnlyList<IReadOnlyList<long>> integerVectors = null,
+      IReadOnlyList<IReadOnlyList<double>> floatVectors = null,
+      IReadOnlyList<IReadOnlyList<string>> stringVectors = null);
 
     void Run(bool stepwise);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15189)
@@ -2,4 +2,5 @@
   using System;
   using System.Collections.Generic;
+  using System.Linq;
   using System.Runtime.CompilerServices;
   using System.Threading;
@@ -35,5 +36,5 @@
       BooleanVectorStack = new PushStack<IReadOnlyList<bool>>();
       StringVectorStack = new PushStack<IReadOnlyList<string>>();
-      PrintStack = new PushStack<string>();
+      PrintStack = new PrintStack();
 
       Stacks = new Dictionary<StackTypes, IPushStack> {
@@ -53,4 +54,6 @@
       };
 
+      supportedStackTypes = Stacks.Keys.ToArray();
+
       CustomExpressions = new Dictionary<string, Expression>();
       PoolContainer = poolContainer ?? new InterpreterPoolContainer();
@@ -63,4 +66,5 @@
     }
 
+    private readonly StackTypes[] supportedStackTypes;
     public IReadOnlyDictionary<StackTypes, IPushStack> Stacks { get; private set; }
 
@@ -128,9 +132,104 @@
     public IPushStack<IReadOnlyList<string>> StringVectorStack { get; private set; }
     [PushStack(StackTypes.Print)]
-    public IPushStack<string> PrintStack { get; private set; }
+    public IPrintStack PrintStack { get; private set; }
 
     public IDictionary<string, Expression> CustomExpressions { get; private set; }
 
     public bool IsNameQuoteFlagSet { get; set; }
+
+    private readonly List<Expression> inputExpressions = new List<Expression>();
+    IReadOnlyList<Expression> IInternalPushInterpreter.InputExpressions { get { return inputExpressions; } }
+
+    public void SetInput(
+      IReadOnlyList<long> integers = null,
+      IReadOnlyList<double> floats = null,
+      IReadOnlyList<bool> booleans = null,
+      IReadOnlyList<char> chars = null,
+      IReadOnlyList<string> strings = null,
+      IReadOnlyList<IReadOnlyList<long>> integerVectors = null,
+      IReadOnlyList<IReadOnlyList<double>> floatVectors = null,
+      IReadOnlyList<IReadOnlyList<string>> stringVectors = null) {
+
+      // Integer
+      if (integers != null && integers.Count > 0) {
+        var integerPushExpressionPool = PoolContainer.GetStatefulExpressionPool<IntegerPushExpression>();
+
+        for (var i = 0; i < integers.Count; i++) {
+          var expression = IntegerPushExpression.Create(integerPushExpressionPool, integers[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // Float
+      if (floats != null && floats.Count > 0) {
+        var floatPushExpressionPool = PoolContainer.GetStatefulExpressionPool<FloatPushExpression>();
+
+        for (var i = 0; i < floats.Count; i++) {
+          var expression = FloatPushExpression.Create(floatPushExpressionPool, floats[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // Booleans
+      if (booleans != null && booleans.Count > 0) {
+        var booleanPushExpressionPool = PoolContainer.GetStatefulExpressionPool<BooleanPushExpression>();
+
+        for (var i = 0; i < booleans.Count; i++) {
+          var expression = BooleanPushExpression.Create(booleanPushExpressionPool, booleans[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // Char
+      if (chars != null && chars.Count > 0) {
+        var charPushExpressionPool = PoolContainer.GetStatefulExpressionPool<CharPushExpression>();
+
+        for (var i = 0; i < chars.Count; i++) {
+          var expression = CharPushExpression.Create(charPushExpressionPool, chars[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // String
+      if (strings != null && strings.Count > 0) {
+        var stringPushExpressionPool = PoolContainer.GetStatefulExpressionPool<StringPushExpression>();
+
+        for (var i = 0; i < strings.Count; i++) {
+          var expression = StringPushExpression.Create(stringPushExpressionPool, strings[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // IntegerVector
+      if (integerVectors != null && integerVectors.Count > 0) {
+        var integerVectorPushExpressionPool = PoolContainer.GetStatefulExpressionPool<IntegerVectorPushExpression>();
+
+        for (var i = 0; i < integerVectors.Count; i++) {
+          var expression = IntegerVectorPushExpression.Create(integerVectorPushExpressionPool, integerVectors[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // FloatVector
+      if (floatVectors != null && floatVectors.Count > 0) {
+        var floatVectorPushExpressionPool = PoolContainer.GetStatefulExpressionPool<FloatVectorPushExpression>();
+
+        for (var i = 0; i < floatVectors.Count; i++) {
+          var expression = FloatVectorPushExpression.Create(floatVectorPushExpressionPool, floatVectors[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+
+      // StringVector
+      if (stringVectors != null && stringVectors.Count > 0) {
+        var stringVectorPushExpressionPool = PoolContainer.GetStatefulExpressionPool<StringVectorPushExpression>();
+
+        for (var i = 0; i < stringVectors.Count; i++) {
+          var expression = StringVectorPushExpression.Create(stringVectorPushExpressionPool, stringVectors[i]);
+          inputExpressions.Add(expression);
+        }
+      }
+    }
+
 
     public Task RunAsync(string code, CancellationToken token = default(CancellationToken)) {
@@ -240,4 +339,5 @@
       currentProgram = null;
 
+      inputExpressions.Clear();
       Clear();
       ConfigureStacks();
@@ -245,6 +345,7 @@
 
     private void ConfigureStacks() {
-      foreach (var pair in this.Stacks) {
-        pair.Value.IsEnabled = Configuration.IsStackEnabled(pair.Key);
+      for (var i = 0u; i < supportedStackTypes.Length; i++) {
+        var key = supportedStackTypes[i];
+        Stacks[key].IsEnabled = Configuration.IsStackEnabled(key);
       }
 
@@ -257,6 +358,8 @@
     /// </summary>
     public void Clear() {
-      foreach (var stack in Stacks)
-        stack.Value.Clear();
+      for (var i = 0u; i < supportedStackTypes.Length; i++) {
+        var key = supportedStackTypes[i];
+        Stacks[key].Clear();
+      }
 
       CustomExpressions.Clear();
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15189)
@@ -47,4 +47,5 @@
       PushProgramPoolProvider.Clear();
       ExpressionListPoolProvider.Clear();
+      pool.Clear();
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/StringBuilderPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/StringBuilderPool.cs	(revision 15189)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/StringBuilderPool.cs	(revision 15189)
@@ -0,0 +1,9 @@
+﻿using System.Text;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+
+  public static class StringBuilderPool {
+    public static readonly ObjectPool<StringBuilder> Instance = new ObjectPool<StringBuilder>(() => new StringBuilder());
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 15189)
@@ -175,7 +175,7 @@
           .Substring(1, word.Length - 2)
           .Split(PushEnvironment.VectorSeparatorSymbol)
-          .ToArray();
-
-        if (vectorEntries.Length == 0) {
+          .ToList();
+
+        if (vectorEntries.Count == 0) {
           expression = null;
           return false;
@@ -190,14 +190,14 @@
 
         if (e.GetType() == typeof(IntegerPushExpression)) {
-          var integerValues = vectorEntries.Select(long.Parse).ToArray();
+          var integerValues = vectorEntries.Select(long.Parse).ToList();
           expression = new IntegerVectorPushExpression(integerValues);
         } else if (e.GetType() == typeof(FloatPushExpression)) {
-          var doubleValues = vectorEntries.Select(x => double.Parse(x, NumberStyles.Float, cultureInfo)).ToArray();
+          var doubleValues = vectorEntries.Select(x => double.Parse(x, NumberStyles.Float, cultureInfo)).ToList();
           expression = new FloatVectorPushExpression(doubleValues);
         } else if (e.GetType() == typeof(StringPushExpression)) {
-          var stringValues = vectorEntries.Select(str => str.Substring(1, str.Length - 2)).ToArray();
+          var stringValues = vectorEntries.Select(str => str.Substring(1, str.Length - 2)).ToList();
           expression = new StringVectorPushExpression(stringValues);
         } else if (e.GetType() == typeof(BooleanPushExpression)) {
-          var booleanValues = vectorEntries.Select(bool.Parse).ToArray();
+          var booleanValues = vectorEntries.Select(bool.Parse).ToList();
           expression = new BooleanVectorPushExpression(booleanValues);
         } else {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15189)
@@ -53,13 +53,23 @@
       var example = Evaluator.Data.Examples[exampleComboBox.SelectedIndex];
 
-      interpreter.BooleanStack.Push(example.InputBoolean);
-      interpreter.IntegerStack.Push(example.InputInteger);
-      interpreter.FloatStack.Push(example.InputFloat);
-      interpreter.CharStack.Push(example.InputChar);
-      interpreter.StringStack.Push(example.InputString);
-      interpreter.IntegerVectorStack.Push(example.InputIntegerVector.Select(x => x.ToList()).ToArray());
-      interpreter.FloatVectorStack.Push(example.InputFloatVector.Select(x => x.ToList()).ToArray());
-      interpreter.StringVectorStack.Push(example.InputStringVector.Select(x => x.ToList()).ToArray());
-      interpreter.BooleanVectorStack.Push(example.InputBooleanVector.Select(x => x.ToList()).ToArray());
+      interpreter.SetInput(
+        integers: example.InputInteger,
+        floats: example.InputFloat,
+        booleans: example.InputBoolean,
+        chars: example.InputChar,
+        strings: example.InputString,
+        integerVectors: example.InputIntegerVector,
+        floatVectors: example.InputFloatVector,
+        stringVectors: example.InputStringVector);
+
+      //interpreter.BooleanStack.Push(example.InputBoolean);
+      //interpreter.IntegerStack.Push(example.InputInteger);
+      //interpreter.FloatStack.Push(example.InputFloat);
+      //interpreter.CharStack.Push(example.InputChar);
+      //interpreter.StringStack.Push(example.InputString);
+      //interpreter.IntegerVectorStack.Push(example.InputIntegerVector.Select(x => x.ToList()).ToList());
+      //interpreter.FloatVectorStack.Push(example.InputFloatVector.Select(x => x.ToList()).ToList());
+      //interpreter.StringVectorStack.Push(example.InputStringVector.Select(x => x.ToList()).ToList());
+      //interpreter.BooleanVectorStack.Push(example.InputBooleanVector.Select(x => x.ToList()).ToList());
     }
 
@@ -198,6 +208,11 @@
             var type = data.OutputArgumentTypes[j];
             var offset = outputArgumentCountDict[type];
+
+            // estimated
             row.Cells[data.InputArgumentTypes.Length + j * 2].Value = ViewHelper.StringifyOutput(type, offset, Content.Config.FloatStringFormat, example, Separator);
+
+            // output
             row.Cells[data.InputArgumentTypes.Length + j * 2 + 1].Value = StringifyResult(type, offset, pushInterpreter, example, Separator);
+
             outputArgumentCountDict[type]++;
           }
@@ -243,5 +258,5 @@
 
         case ExampleArgumentType.Print:
-          return string.Join(valueSeparator, string.Join(PushEnvironment.NewLine, interpreter.PrintStack.Take(example.OutputPrintLineCount)));
+          return string.Join(valueSeparator, string.Join(PushEnvironment.NewLine, interpreter.PrintStack.AsStrings().Take(example.OutputPrintLineCount)));
 
         case ExampleArgumentType.String:
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15189)
@@ -2,4 +2,5 @@
   using System;
   using System.Collections.Generic;
+  using System.Globalization;
   using System.Linq;
 
@@ -130,40 +131,70 @@
       var example = Data.Examples[exampleIndex];
 
-      interpreter.BooleanStack.Push(example.InputBoolean);
-      interpreter.IntegerStack.Push(example.InputInteger);
-      interpreter.FloatStack.Push(example.InputFloat);
-      interpreter.CharStack.Push(example.InputChar);
-      interpreter.StringStack.Push(example.InputString);
-      interpreter.StringVectorStack.Push(example.InputStringVector);
-      interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
-      interpreter.FloatVectorStack.Push(example.InputFloatVector);
+      //interpreter.BooleanStack.Push(example.InputBoolean);
+      //interpreter.IntegerStack.Push(example.InputInteger);
+      //interpreter.FloatStack.Push(example.InputFloat);
+      //interpreter.CharStack.Push(example.InputChar);
+      //interpreter.StringStack.Push(example.InputString);
+      //interpreter.StringVectorStack.Push(example.InputStringVector);
+      //interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
+      //interpreter.FloatVectorStack.Push(example.InputFloatVector);
+
+      interpreter.SetInput(
+        integers: example.InputInteger,
+        floats: example.InputFloat,
+        booleans: example.InputBoolean,
+        chars: example.InputChar,
+        strings: example.InputString,
+        integerVectors: example.InputIntegerVector,
+        floatVectors: example.InputFloatVector,
+        stringVectors: example.InputStringVector);
 
       interpreter.Run(program);
 
       switch (Data.ProblemType) {
-        //case ProblemType.NumberIO:
-        //  if (interpreter.PrintStack.IsEmpty)
-        //    return Data.WorstResult;
-
-        //  double value;
-        //  var levenshteinDistance = GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, example.OutputPrintLineCount, Data.WorstResult);
-        //  return levenshteinDistance + (double.TryParse(interpreter.PrintStack.Top, out value)
-        //    ? FloatDiffer(value, example.OutputFloat[0], example.OutputFloatPrecision)
-        //    : Data.WorstResult / 2);
-
-        case ProblemType.Median: return interpreter.PrintStack.IsEmpty ? 1 : interpreter.PrintStack.Top.Equals(example.OutputPrint) ? 0 : 1;
-      }
-
+        case ProblemType.NumberIO: return NumberIo(interpreter, example);
+        case ProblemType.Median: return Median(interpreter, example);
+      }
+
+      return Default(interpreter, example);
+    }
+
+    private double Default(IPushInterpreter interpreter, Example example) {
       var result = GetDiff(example.OutputInteger, interpreter.IntegerStack, Data.WorstResult, IntegerDiffer)
-                 + GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision))
-                 + GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer)
-                 + GetDiff(example.OutputString, interpreter.StringStack, Data.WorstResult, StringDiffer)
-                 + GetDiff(example.OutputChar, interpreter.CharStack, Data.WorstResult, CharDiffer)
-                 + GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, example.OutputPrintLineCount, Data.WorstResult)
-                 + GetVectorDiff(example.OutputIntegerVector, interpreter.IntegerVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, IntegerDiffer))
-                 + GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, (x, y) => FloatDiffer(x, y, example.OutputFloatVectorPrecision)))
-                 + GetVectorDiff(example.OutputStringVector, interpreter.StringVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, StringDiffer));
+             + GetDiff(example.OutputFloat, interpreter.FloatStack, Data.WorstResult, (a, b) => FloatDiffer(a, b, example.OutputFloatPrecision))
+             + GetDiff(example.OutputBoolean, interpreter.BooleanStack, Data.WorstResult, BooleanDiffer)
+             + GetDiff(example.OutputString, interpreter.StringStack, Data.WorstResult, StringDiffer)
+             + GetDiff(example.OutputChar, interpreter.CharStack, Data.WorstResult, CharDiffer)
+             + GetPrintDiffer(example.OutputPrint, interpreter.PrintStack, example.OutputPrintLineCount, Data.WorstResult)
+             + GetVectorDiff(example.OutputIntegerVector, interpreter.IntegerVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, IntegerDiffer))
+             + GetVectorDiff(example.OutputFloatVector, interpreter.FloatVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, (x, y) => FloatDiffer(x, y, example.OutputFloatVectorPrecision)))
+             + GetVectorDiff(example.OutputStringVector, interpreter.StringVectorStack, Data.WorstResult, (a, b) => VectorDiffer(a, b, StringDiffer));
 
       return result;
+    }
+
+    private double Median(IPushInterpreter interpreter, Example example) {
+      return interpreter.PrintStack.IsEmpty || !interpreter.PrintStack.Top.Equals(example.OutputPrint) ? 1 : 0;
+    }
+
+    private double NumberIo(IPushInterpreter interpreter, Example example) {
+      if (interpreter.PrintStack.IsEmpty)
+        return Data.WorstResult;
+
+      double value;
+      if (double.TryParse(interpreter.PrintStack.Top, NumberStyles.Number | NumberStyles.AllowDecimalPoint, CultureInfo.InvariantCulture, out value)) {
+        var diff = Math.Abs(example.OutputFloat[0] - value);
+        var result = Math.Min(diff, Data.WorstResult);
+
+        return result;
+      }
+
+      var penaltyError = Data.WorstResult / 4.0d;
+      var levenshteinDistance = GetPrintDiffer(
+        example.OutputPrint,
+        interpreter.PrintStack.Top,
+        Data.WorstResult);
+
+      return levenshteinDistance + penaltyError;
     }
 
@@ -217,6 +248,12 @@
     }
 
+    private static double GetPrintDiffer(string estimated, string printResult, double worstResult) {
+      var distance = LevenshteinDistance(estimated, printResult);
+
+      return Math.Min(distance, worstResult);
+    }
+
     private static double GetPrintDiffer(string estimated, IPushStack<string> printStack, int estimatedCount, double worstResult) {
-      var printResult = string.Join(PushEnvironment.NewLine, printStack.Take(estimatedCount));
+      var printResult = string.Join(PushEnvironment.NewLine, printStack.AsStrings().Take(estimatedCount));
       var distance = LevenshteinDistance(estimated, printResult);
 
@@ -234,5 +271,5 @@
         var count = Math.Min(estimated.Count, resultStack.Count);
         var result = resultStack.Peek(count);
-        comparableLength = Math.Min(estimated.Count, result.Length);
+        comparableLength = Math.Min(estimated.Count, result.Count);
 
         for (var i = 0; i < comparableLength; i++) {
@@ -259,5 +296,5 @@
         var count = Math.Min(estimated.Count, resultStack.Count);
         var result = resultStack.Peek(count);
-        comparableLength = Math.Min(estimated.Count, result.Length);
+        comparableLength = Math.Min(estimated.Count, result.Count);
 
         for (var i = 0; i < comparableLength; i++) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15033)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15189)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
+
   using Common;
   using Configuration;
@@ -7,4 +8,5 @@
   using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Instances;
@@ -53,4 +55,5 @@
 
       config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
+      data.InitInExpressions(config);
 
       Encoding.Bounds[0, 0] = 0;
